#if !defined(PBM_MINI_VERSION_H)
#define PBM_MINI_VERSION_H


#if defined(USE_EXPORT)
#define PBM_MINI_EXP_API(funcName) EXP_PBM_Mini_##funcName
#else
#define PBM_MINI_EXP_API(funcName) PBM_Mini_##funcName
#endif

#define DECLARE_PBM_MINI_EXP(funcName) GEN_EXPORT PBM_MINI_EXP_API(funcName)

void
DECLARE_PBM_MINI_EXP(ComponentGetExtensionSize)(
	OUT bpMEMORY_REQUIREMENT	pMemRequirement );

void
DECLARE_PBM_MINI_EXP(ComponentGetDIMMRequirement)(
	IN U32						VenDevID,
	IN U32						SubVenDevID,
	IN OUT bpMEMORY_REQUIREMENT	pMemRequirement );

void
DECLARE_PBM_MINI_EXP(ComponentInitialize)(
	IN bpVOID				ComponentExtension,
	IN bpMEMORY_AVAILABLE	pMemAvail,
	IN U32					VenDevID,
	IN U32					SubVenDevID,
	IN bpVOID				ComponentSpecificContext );

void
DECLARE_PBM_MINI_EXP(ComponentStart)(
	IN bpVOID	ComponentExtension,
	IN DIMMADDR DIMMOffset,
	IN U32		DIMMSize );

void 
DECLARE_PBM_MINI_EXP(SubmitRAID)(
	IN bpVOID PBMComponentExtension,
	IN bpREQ p_rq );

void
DECLARE_PBM_MINI_EXP(OnLogicalDeviceRemoval) (
	bpVOID	PBMComponentExtension,
	U8		LogicalDeviceID );

void
DECLARE_PBM_MINI_EXP(OnLogicalDeviceArrival)(
	bpVOID	PBMComponentExtension,
	U8		LogicalDeviceID );

#endif
