#if !defined(OSD_TIMER_H)
#define OSD_TIMER_H

/*
struct 	linux_list_head {
	struct linux_list_head *next, *prev;
};

struct linux_timer_list{
	struct linux_list_head list;
	U32 expires;
	U32 data;
	void (*function)(U32);
}; 

void linux_init_timer(struct linux_timer_list * timer);
void linux_add_timer(struct linux_timer_list * timer); 
void linux_del_timer(struct linux_timer_list * timer);

*/
unsigned long volatile linux_get_jiffies(void);
void linux_delay(U32 DelayTime);

struct Timer_Queue{
	/* struct linux_timer_list *list; */
	struct timer_list *list;
	struct Timer_Queue *next;
	GEN_TIMER_CALLBACK  callback;
	void * pdata;
	void * pContext;
	U32	flag;	//0: free 1: assigned
	unsigned long ControlFlags;
};
typedef struct Timer_Queue Timer_Queue_t;

unsigned long volatile 
linux_get_jiffies(void);

void 
init_timer_queue(bpVOID OSDExtension);

struct Timer_Queue * 
alloc_timer_queue(bpVOID OSDExtension);

void 
release_timer_queue(bpVOID OSDExtension, struct Timer_Queue *ptimer);

#endif /* OSD_TIMER_H */
